<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInFlightService ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfInFlightService extends AbstractStructArrayBase
{
    /**
     * The inFlightSrv
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgInFlightSrv[]
     */
    public $inFlightSrv;
    /**
     * Constructor method for ArrayOfInFlightService
     * @uses DgArrayOfInFlightService::setInFlightSrv()
     * @param \dgsoft\StructType\DgInFlightSrv[] $inFlightSrv
     */
    public function __construct(array $inFlightSrv = array())
    {
        $this
            ->setInFlightSrv($inFlightSrv);
    }
    /**
     * Get inFlightSrv value
     * @return \dgsoft\StructType\DgInFlightSrv[]|null
     */
    public function getInFlightSrv()
    {
        return $this->inFlightSrv;
    }
    /**
     * Set inFlightSrv value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgInFlightSrv[] $inFlightSrv
     * @return \dgsoft\ArrayType\DgArrayOfInFlightService
     */
    public function setInFlightSrv(array $inFlightSrv = array())
    {
        foreach ($inFlightSrv as $arrayOfInFlightServiceInFlightSrvItem) {
            // validation for constraint: itemType
            if (!$arrayOfInFlightServiceInFlightSrvItem instanceof \dgsoft\StructType\DgInFlightSrv) {
                throw new \InvalidArgumentException(sprintf('The inFlightSrv property can only contain items of \dgsoft\StructType\DgInFlightSrv, "%s" given', is_object($arrayOfInFlightServiceInFlightSrvItem) ? get_class($arrayOfInFlightServiceInFlightSrvItem) : gettype($arrayOfInFlightServiceInFlightSrvItem)), __LINE__);
            }
        }
        $this->inFlightSrv = $inFlightSrv;
        return $this;
    }
    /**
     * Add item to inFlightSrv value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgInFlightSrv $item
     * @return \dgsoft\ArrayType\DgArrayOfInFlightService
     */
    public function addToInFlightSrv(\dgsoft\StructType\DgInFlightSrv $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgInFlightSrv) {
            throw new \InvalidArgumentException(sprintf('The inFlightSrv property can only contain items of \dgsoft\StructType\DgInFlightSrv, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->inFlightSrv[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgInFlightSrv|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgInFlightSrv|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgInFlightSrv|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgInFlightSrv|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgInFlightSrv|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string inFlightSrv
     */
    public function getAttributeName()
    {
        return 'inFlightSrv';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfInFlightService
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
